package tools

import "os"

func StringSliceToFile(stringSlice []string, filename string) error {
	file, err := os.Create(filename)
	if err != nil {
		return err
	}
	defer file.Close()

	if len(stringSlice) == 0 {
		if _, err := file.WriteString("None"); err != nil {
			return err
		}
	} else {
		for _, entry := range stringSlice {
			if _, err := file.WriteString(entry); err != nil {
				return err
			}
		}
	}
	return nil
}
